-- Section 6.2

module CayleyNearsemiring where

import Data.Monoid

import Nearsemiring

newtype DC n = DC ((n -> n) -> (n -> n))

instance Monoid n =>  Nearsemiring (DC n) where
   DC f .* DC g  = DC (f . g)
   one           = DC id
   DC f .+ DC g  = DC (\h -> f h . g h)
   zero          = DC (const id)

rep :: Nearsemiring n => n -> DC n
rep x = DC (\h y -> (x .* h zero) .+ y)

abs :: Nearsemiring n => DC n -> n
abs (DC f) = f (\x -> one .+ x) zero
