{-# LANGUAGE RankNTypes #-}

-- Section 5.4

module FreeMonadPlus where

import Control.Applicative
import Control.Monad
import Prelude

data FMP f x = FMP { unFMP :: [TFMP f x] }

data TFMP f x = PureFMP x | ConFMP (f (FMP f x))

instance Functor f => Functor (FMP f) where
  fmap f x = x >>= return . f

instance Functor f => Applicative (FMP f) where
   pure = return
   (<*>) = ap

instance Functor f => Alternative (FMP f) where
   empty = mzero
   (<|>) = mplus

instance Functor f => Monad (FMP f) where
  return x = FMP [PureFMP x]
  FMP xs >>= f = FMP (concatMap g xs)
    where  g (PureFMP x)  = unFMP (f x)
           g (ConFMP x)   = [ConFMP (fmap (>>= f) x)]

instance Functor f => MonadPlus (FMP f) where
  mzero = FMP []
  FMP xs `mplus` FMP ys = FMP (xs ++ ys)

inj :: Functor f => f a -> FMP f a
inj x = FMP [ConFMP (fmap return x)]

univ :: (MonadPlus m, Functor f) => (forall x . f x -> m x) -> FMP f x -> m x
univ h (FMP l)  = foldr mplus mzero (map univT l)
                 where    univT (PureFMP x)  =  return x
                          univT (ConFMP op)  =  h op >>= univ h
