-- Section 5.2

module FreeNearsemiring where

import Prelude

import Nearsemiring

data FNS   a  = FNS [FFNS a]
data FFNS  a  = Pure | Con a (FNS a)

instance Nearsemiring (FNS a) where
  zero                     = FNS []
  one                      = FNS [Pure]
  (FNS xs) .+ (FNS ys)  = FNS (xs ++ ys)
  (FNS xs) .* (FNS ys)  = FNS (concatMap g xs)
                   where  g Pure        = ys
                          g (Con a n)   = [Con a (n .* (FNS ys))]

inj :: a -> FNS a
inj a = FNS [Con a one]

univ :: Nearsemiring n => (a -> n) -> FNS a -> n
univ h (FNS xs)  =  foldr (.+) zero (map univT xs)
  where  univT Pure        =  one
         univT (Con a ts)  =  (h a) .* (univ h ts)
