{-# LANGUAGE FlexibleInstances, DeriveFunctor #-}

-- Section 9.1

module HeristicSearch where

import Control.Monad

import FreeMonadPlus

class MonadPlus m => Bunch m where
  wrap :: m a -> m a

newtype Identity a = Id {runId :: a} deriving Functor

instance Bunch (FMP Identity) where
  wrap xf = FMP [ConFMP (Id xf)]

search  :: Bunch m => FMP Identity a -> m a
search = univ (wrap . return . runId) 

dbs :: Int -> FMP Identity a -> FMP Identity a
dbs 0 _    =  mzero
dbs n (FMP ts) = FMP (map go ts)
  where  go (PureFMP a)      =  PureFMP a
         go (ConFMP (Id f))  =  ConFMP (Id (dbs (n-1) f))
