-- Section 9.2

module InterleavingParser where

import Control.Monad
import Control.Applicative hiding (many)
import Text.ParserCombinators.Parsec.Char

import FreeAlternative

type P = CharParser ()


(<++>) :: Functor f => FreeAlt f a -> FreeAlt f b -> FreeAlt f (a,b)
ga <++> gb  =               FreeAlt [ fa `fwdby` gb  | fa <- fas ]
            <|>  (swap <$>  FreeAlt [ fb `fwdby` ga  | fb <- fbs ])
            <|>             FreeAlt [ PureFA (a,b)   | a <- as, b <- bs ]
  where   swap (a,b)  = (b,a)
          (as, fas)   = split ga
          (bs, fbs)   = split gb

split :: FreeAlt f a -> ([a], [Alt f a])
split (FreeAlt l)  =  ([a | PureFA a     <- l] , [ f | f@(ConFA p r)  <- l])

fwdby ::  Functor f => Alt f a -> FreeAlt f b -> Alt f (a, b)
(ConFA pa ra) `fwdby`  fbs  =  ConFA (fmap first pa) (ra <++> fbs)
                       where first f (c,b)  =  (f c, b)
